package classicaltm;

import javax.swing.SwingUtilities;

import gui.GUI;

/**
 * An application that simulates Turing machines.
 *
 * @author Ziyed, Willem, Olav
 */
public class TuringSimulator {

    /**
     * The current version of the application.
     */
    public static final String VERSION = "1.3";

    /**
     * The main GUI of the application.
     */
    private static GUI gui;

    /**
     * Starts the application.
     *
     * @param args The command line arguments (ignored).
     */
    public static void main(String[] args) {
        SwingUtilities.invokeLater(new Runnable() {

            @Override
            public void run() {
                gui = new GUI();
                gui.setSize(800, 450);
                gui.setLocationRelativeTo(null);
                gui.setVisible(true);
            }
        });
    }
}
