package gui;

/**
 * Thrown when the parsing of a Turing program fails.
 */
public class ParseException extends Exception {

    /**
     * The line number where the syntax error occurred.
     */
    private int lineNumber;

    /**
     * Creates a new parse exception.
     *
     * @param message A message that explains the error.
     * @param lineNumber The line number where the error occurred.
     */
    public ParseException(String message, int lineNumber) {
        super(message);

        this.lineNumber = lineNumber;
    }

    /**
     * Returns the line number where the syntax error occurred.
     *
     * @return The line number.
     */
    public int getLineNumber() {
        return lineNumber;
    }
}
