package gui;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JToolBar;

import gui.SimulatorTab.SimulatorMode;

/**
 * TODO this part of the GUI needs a redesign...
 */
public class SimulatingToolBar extends JToolBar {

    private SimulatorTab simulatorTab;

    JButton singleStepButton;
    JButton runUntilFinishedButton;
    JButton resetSimulationButton;

    /**
     * Creates a new simulation toolbar.
     *
     * @param s The simulator tab this toolbar is for.
     */
    public SimulatingToolBar(SimulatorTab s) {

        this.simulatorTab = s;

        setFloatable(false);

        singleStepButton = new JButton("Single step");
        singleStepButton.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {

                // perform a step
                simulatorTab.getTuringMachine().step();

                // if we cannot do any transition, go to the output mode
                if (simulatorTab.getTuringMachine().activeTransition() == null) {
                    ArrayList<Character> output = simulatorTab.getTuringMachine().getTape().readOutput();
                    String outputString = "";
                    if (output != null) {
                        for (Character c : output) {
                            outputString += c;
                        }
                    }
                    outputString = outputString.trim();
                    simulatorTab.outputToolBar.setOutputText(outputString);
                    simulatorTab.setMode(SimulatorMode.SHOWING_OUTPUT);
                }

                // since the Turing machine has changed, we need to update the values shown
                simulatorTab.updateValues();
            }
        });
        add(singleStepButton);

        runUntilFinishedButton = new JButton("Run until finished");
        runUntilFinishedButton.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                simulatorTab.startStepTimer();
            }
        });
        add(runUntilFinishedButton);

        resetSimulationButton = new JButton("Reset simulation");
        resetSimulationButton.addActionListener(new ActionListener() {

            @Override
            public void actionPerformed(ActionEvent e) {
                simulatorTab.getTuringMachine().reset();
                simulatorTab.setMode(SimulatorMode.ASKING_INPUT);
                simulatorTab.updateValues();
            }
        });
        add(resetSimulationButton);
    }
}
